#include <pic.h>
#include <sys.h>
#include <main.h>

void  GeneralProc(void);

extern bank1 struct controlb modLED;
extern bank2 struct controlb modSir;
extern unsigned int BlockTimeOut;
extern unsigned char  MODE;
extern  bit bitTaskSw;   //        
extern  bit oldPin_Door; //    
extern  bit oldPin_ACC;  //    
extern  bit bitACC_ON;   //   
extern  bit bitACC_OFF;  //   
extern  bit bitDoor_Open;//   
extern  bit bitCodeAccepted1; //    1 
extern  bit bitCodeAccepted2; //    2 
extern  bit bitFault;         //     
extern  bit bitEngineEnabled; //   
extern  bit bitAttemptScanning;   //     

extern bank3 unsigned int timer1;
extern bank3 unsigned char counter1;

extern bank2 struct {             
unsigned Ant1Enabled:1;
unsigned Ant2Enabled:1;
unsigned phaze      :1;
unsigned            :5; 
} modAnt;                //      

extern bank2 struct {              //      Open, Close
unsigned start  :1;
unsigned phaze  :1;
unsigned enabled:1;
unsigned stop   :1;
unsigned        :4;
} modOpen, modClose;

extern bank1 unsigned char modLEDMode;
extern bank2 unsigned char modSirMode;


void  GeneralProc(void)
{
  switch (MODE)
  {
  	
//--------------------------------------------------------------------------------------------------------
//         
//  	
  case mdAlarm:
  
	  if (bitCodeAccepted1) goto SetArmReleaseMode;//     1 
    ++timer1;
	  if (timer1>IT(40/2)) //   40       
	  {
      timer1=0;
	    ++counter1;
      if (((Pin_ACC==1) && (Pin_Door==0)) || (counter1>2))  //       
      {                                              //         
        goto SetArmModeBreak;
      }
	  }	
    return;
    
    
//--------------------------------------------------------------------------------------------------------
//         
//  	
  case mdArm:
    if (counter1>0)
    {  
      --counter1;
    }
    else
    {
      if (bitDoor_Open || bitACC_ON || bitAttemptScanning) goto SetAlarmMode; //       
    }	

    if (bitCodeAccepted1) goto SetArmReleaseMode;     //        1
    return;
//--------------------------------------------------------------------------------------------------------
//          
//  	
  case mdArmRelease:
    ++timer1;
	  if (timer1>IT(20/2)) goto SetArmMode; //   20       
    if (bitACC_ON) goto SetBlock1Mode;
    if (bitDoor_Open) goto SetBlock1Mode;
CheckID:  
	  if (bitCodeAccepted2) goto SetDriveMode;
	  if (bitCodeAccepted1) goto SetArmMode;
    break;
//--------------------------------------------------------------------------------------------------------
//          1  "Anti-Drive"
//  	
  case mdBlock1:
    if (bitACC_ON) 
    {
    	++counter1;
    	if (counter1>2)
    	{
    		modClose.start=1;
    		goto SetAlarmMode;
    	}	 
    }	 

    goto CheckID;
//--------------------------------------------------------------------------------------------------------
//          2  "Anti-Robbery"
//  	
  case mdBlock2:
    if (bitACC_ON) 
    {
    	++counter1;  
    	bitEngineEnabled=1;
    	switch (counter1)
    	{
        
    		case 1:
    		{
    			BlockTimeOut=BLOCK2_2;
    			break;
    		}	
    		case 2:
    		{
    			BlockTimeOut=BLOCK2_3;
    			break;
    		}	
    		case 3:
    		{
    			BlockTimeOut=BLOCK2_4;
    			break;
    		}	
				case 4: goto SetAlarmMode;
    	}	
    }	
    goto CheckID;
//--------------------------------------------------------------------------------------------------------
//          
//  	
  case mdDrive: 
	  if (bitCodeAccepted1) goto SetArmMode; //     1
    if (bitDoor_Open) goto SetBlock2Mode;
    break;
  }  
  return;
  
SetArmReleaseMode:
  MODE=mdArmRelease;
  bitEngineEnabled=0;
  modLEDMode=mdLEDArm_Release;
  modSirMode=mdSirArm_OFF;
  modOpen.start=1;
  modAnt.Ant2Enabled=1;
  timer1=0;
  return;

SetAlarmMode:
  MODE=mdAlarm;
  modLEDMode=mdLEDAlarm;
  modSirMode=mdSirAlarm;
  bitEngineEnabled=0;
  timer1=0;
  counter1=0;
  return;

SetArmModeBreak:
  MODE=mdArm;
  modLEDMode=mdLEDArm_Break;
  modSir.stop=1;
  bitEngineEnabled=0;
  bitAttemptScanning=0;
  modAnt.Ant2Enabled=0;
  return;

SetArmMode: 
  if (!Pin_ACC) return; //        
  if (Pin_Door)
  {
  	modSirMode=mdSirArm_ONWarning; //      
  }	
  else
  {
  	modSirMode=mdSirArm_ON;
  }	
  MODE=mdArm;
  modClose.start=1;
  modLEDMode=mdLEDArm;
  bitEngineEnabled=0;
  bitAttemptScanning=0;
  modAnt.Ant2Enabled=0;
  counter1=CT(5/2);
  return;



SetDriveMode:
  MODE=mdDrive;
  modLEDMode=mdLEDCod2Confirm;
  BlockTimeOut=0;
  modSir.stop=1;
  bitEngineEnabled=1;
  modAnt.Ant2Enabled=0;
	return;  


SetBlock1Mode:
  MODE=mdBlock1;
  modLEDMode=mdLEDBlockACCOn;
  BlockTimeOut=BLOCK2_2;
  bitEngineEnabled=1;
  modAnt.Ant2Enabled=1;
  counter1=0;
	return;  

SetBlock2Mode:
  MODE=mdBlock2;
  modLEDMode=mdLEDBlockACCOn;
  BlockTimeOut=BLOCK2_1;
  bitEngineEnabled=1;
  modAnt.Ant2Enabled=1;
  counter1=0;
	return;  

  
};

