#include <pic.h>
#include <sys.h>
#include <main.h>

void Task_LED(void);

bank1 unsigned char LEDOn;     //     
bank1 unsigned char LEDOff;    //     
bank1 unsigned char LEDPulse;  //      
bank1 unsigned char LEDPeriod; //      
bank1 unsigned char cntLED;       //   
bank1 unsigned char cntLEDPulse;  //   
bank1 unsigned char cntLEDPeriod; //      
bank1 struct controlb modLED;

extern bank1 unsigned char modLEDMode;
//-------------------------------------------      
//   LED
//
//  :
//    StartMode   
//   Stop    
//   single        
//-------------------------------------------
void Task_LED(void)
{
	if (modLEDMode!=0)
	{
	  modLED.single=0;
	  switch (modLEDMode)
	  {
	  case mdLEDArm:
	    LEDOn=LEDARM_ON;
	    LEDOff=LEDARM_OFF;
	    LEDPulse=LEDARM_PULSE;
	    LEDPeriod=LEDARM_PERIOD;
	    break;        
	  case mdLEDArm_Break:
	    LEDOn=LEDARMBREAK_ON;
	    LEDOff=LEDARMBREAK_OFF;
	    LEDPulse=LEDARMBREAK_PULSE;
	    LEDPeriod=LEDARMBREAK_PERIOD;
	    break;
	  case mdLEDArm_Release:
	    LEDOn=LEDARMRELEASE_ON;
	    LEDOff=LEDARMRELEASE_OFF;
	    LEDPulse=LEDARMRELEASE_PULSE;
	    LEDPeriod=LEDARMRELEASE_PERIOD;
	    break;        
	  case mdLEDBlockACCOn:
	    LEDOn=LEDARMBLOCKACCON_ON;
	    LEDOff=LEDARMBLOCKACCON_OFF;
	    LEDPulse=LEDARMBLOCKACCON_PULSE;
	    LEDPeriod=LEDARMBLOCKACCON_PERIOD;
	    break;        
	  case mdLEDBlockACCOff:
	    LEDOn=LEDARMBLOCKACCOFF_ON;
	    LEDOff=LEDARMBLOCKACCOFF_OFF;
	    LEDPulse=LEDARMBLOCKACCOFF_PULSE;
	    LEDPeriod=LEDARMBLOCKACCOFF_PERIOD;
	    break;
	  case mdLEDCod2Confirm:
	    LEDOn=LEDARMCOD2CONFIRM_ON;
	    LEDOff=LEDARMCOD2CONFIRM_OFF;
	    LEDPulse=LEDARMCOD2CONFIRM_PULSE;
	    LEDPeriod=LEDARMCOD2CONFIRM_PERIOD;
	    modLED.single=1;
	    break;
	  default:
	    modLED.stop=1;
	  }
	  cntLEDPeriod=0;
	  cntLED=0;
	  modLED.enabled=1;
	  modLEDMode=0;
	  modLED.phaze=0;
	}        
	
	if (modLED.stop) //   Stop    
	{
	  modLED.stop=0;
	  modLED.enabled=0;
	  Pin_LED=0; 
	  return;         //  
	} 
	
	
	if (modLED.enabled)
	{
	
	  if (cntLEDPeriod==0) //      
	  {
	    cntLEDPulse=LEDPulse;
	    cntLEDPeriod=LEDPeriod;
	  } 
	  --cntLEDPeriod; 
	
	
    if (cntLED==0)
    {          
  	  if (cntLEDPulse==0) //        
	    {
        if (modLED.single) modLED.enabled=0; //       
    	  return;
    	}
      --cntLEDPulse;
      
      if (modLED.phaze)
      {
        //    1   0
        Pin_LED=0;
        cntLED=LEDOff; 
        modLED.phaze=0;
      }
      else
      {
	      //    0   1
        Pin_LED=1;
        cntLED=LEDOn;
        modLED.phaze=1;
      }
    }  // if (cntLED==0)
    --cntLED;
	}
};
