LIST
C       equ     0
Z       equ     2
PCL	equ     2
PORTB   equ     6
TMR0    equ     1 
STATUS  equ     3

SKIP_IF_IN_HIGH macro 
  BTFSS   PORTB,3
endm

SKIP_IF_IN_LOW  macro
  BTFSC   PORTB,3
endm


	global	_CodeReception
	signat	_CodeReception,1097
	FNSIZE	_CodeReception,3,1
;	FNADDR	_CodeReception

  global   _COD1, _COD2, _COD3, _COD4, _COD5, _COD6, _COD7, _COD8

	psect	receipt,global,class=CODE,delta=2


	psect	temp,global,ovrld,class=BANK0,space=1
COUNT  	ds	1
COUNT2  ds  1
TMP1    ds  1


  psect receipt
  

;+--------------------------------------------------------------------------+
;                                                
;+--------------------------------------------------------------------------+
;          
;       64   (16)    
;            ---+              +----
;                             
;                             
;               +--------------+
;                252..336  
;
;          ,       
;             .
;
_CodeReception

        CLRF    _COD1
        CLRF    _COD2
        CLRF    _COD3
        CLRF    _COD4
        CLRF    _COD5
        CLRF    _COD6
        CLRF    _COD7
        CLRF    _COD8
        CLRF    COUNT

        MOVLW   63
        MOVWF   COUNT2
SYNC1:  ;   .1
        SKIP_IF_IN_LOW
        GOTO    SYNC2
        BTFSS   TMR0,7    ;   128  ,
                          ;    
        GOTO    SYNC1
        RETLW   0

SYNC2:  ;  
        SKIP_IF_IN_HIGH
        GOTO    SYNC3
        BTFSS   TMR0,7    ;   128  ,
                          ;    
        GOTO    SYNC2
        RETLW   0

SYNC3:  ;  .    
        ;  
        SKIP_IF_IN_LOW   ; 1
        GOTO    SYNC4    ; 1
        INCF    COUNT    ; 1
        BTFSS   COUNT,6  ; 1    64   (64*6=384 ),
                         ;      
        GOTO    SYNC3    ; 2
        GOTO    _CodeReception
SYNC4:
        MOVLW   42         ; 1
        SUBWF   COUNT,W    ; 1  COUNT-42
        BTFSS   STATUS,C   ; 1
        GOTO    _CodeReception ; 1     252 . 
        MOVLW   56         ; 1
        SUBWF   COUNT,W    ; 1  COUNT-56
        BTFSC   STATUS,C   ; 1
        GOTO    _CodeReception ; 1     336 . 
        ;
        ;       10..16 
        ;     = 1
        ;
        ;
        ;      127 
        ;
        ;  127-11=116 
        MOVLW   38         ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        BSF     STATUS,C   ; 1

RECEIPTBIT:
        RLF     _COD8    ; 1
        RLF     _COD7    ; 1
        RLF     _COD6    ; 1
        RLF     _COD5    ; 1
        RLF     _COD4    ; 1
        RLF     _COD3    ; 1
        RLF     _COD2    ; 1
        RLF     _COD1    ; 1
        NOP             ; 1
        NOP             ; 1
        NOP             ; 1
        NOP             ; 1  -> 12

;         
;
;           1      2     3
;                        ( )     ( )  (  )
;
;       00                 64             128           64
;       01                 40             176           40
;       10                 72             112           72
;       11                 32             160           64
;
        ;
        ;    
        ;
        MOVLW   00000011B  ; 1
        ANDWF   _COD8,W    ; 1
        ADDWF   PCL        ; 2
        GOTO    PREBIT00   ; 2 SUM 5
        GOTO    PREBIT01   ;
        GOTO    PREBIT10   ;
        GOTO    PREBIT11   ;
PREBIT00:
        ;  64-20=44 
        MOVLW   14         ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        CLRF    TMP1       ; 1
        ;
        ;    
        ;
        BSF     STATUS,C   ; 1
        SKIP_IF_IN_HIGH    ; 1
        BCF     STATUS,C   ; 1
        RLF     TMP1       ; 1     

        ;  128-4=124 

        MOVLW   40         ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        NOP                ; 1
        NOP                ; 1
        NOP                ; 1
        ;
        ;    
        ;
        BSF     STATUS,C   ; 1
        SKIP_IF_IN_HIGH    ; 1
        BCF     STATUS,C   ; 1
        RLF     TMP1       ; 1     

        ;  64-14=50 
        MOVLW   16         ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        NOP                ; 1
        GOTO    DECODEBIT  ; 2

PREBIT01:
        ;  40-20=20 
        MOVLW   6          ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        CLRF    TMP1       ; 1
        ;
        ;    
        ;
        BSF     STATUS,C   ; 1
        SKIP_IF_IN_HIGH    ; 1
        BCF     STATUS,C   ; 1
        RLF     TMP1       ; 1     

        ;  176-4=172 
        MOVLW   56         ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        NOP                ; 1
        NOP                ; 1
        NOP                ; 1
        ;
        ;    
        ;
        BSF     STATUS,C   ; 1
        SKIP_IF_IN_HIGH    ; 1
        BCF     STATUS,C   ; 1
        RLF     TMP1       ; 1     

        ;  40-14=26 
        MOVLW   8          ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        NOP                ; 1
        GOTO    DECODEBIT  ; 2

PREBIT10:
        ;  72-20=52 
        MOVLW   16         ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
				NOP		   ; 1
				NOP		   ; 1
        CLRF    TMP1       ; 1

        ;
        ;    
        ;
        BSF     STATUS,C   ; 1
        SKIP_IF_IN_HIGH    ; 1
        BCF     STATUS,C   ; 1
        RLF     TMP1       ; 1     
        ;
        ;  112-4=108 
        ;
        MOVLW   35         ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        NOP                ; 1
        NOP                ; 1
        ;
        ;    
        ;
        BSF     STATUS,C   ; 1
        SKIP_IF_IN_HIGH    ; 1
        BCF     STATUS,C   ; 1
        RLF     TMP1       ; 1     

        ;  72-14=58 
        MOVLW   18         ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        NOP                ; 1
	      NOP         		   ; 1
	      NOP		             ; 1
        GOTO    DECODEBIT  ; 2

PREBIT11:
        ;  32-20=12 
        MOVLW   3          ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        CLRF    TMP1       ; 1
        NOP                ; 1
        ;
        ;    
        ;
        BSF     STATUS,C   ; 1
        SKIP_IF_IN_HIGH    ; 1
        BCF     STATUS,C   ; 1
        RLF     TMP1       ; 1     

        ;  160-4=156 
        MOVLW   51         ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        NOP                ; 1
        NOP                ; 1
        ;
        ;    
        ;
        BSF     STATUS,C   ; 1
        SKIP_IF_IN_HIGH    ; 1
        BCF     STATUS,C   ; 1
        RLF     TMP1       ; 1     

        ;  64-14=50 
        MOVLW   16         ; 1
        MOVWF   COUNT      ; 1
        DECFSZ  COUNT      ; 1
        GOTO    $-1        ; 2
        NOP                ; 1
        GOTO    DECODEBIT  ; 2


DECODEBIT:
        MOVLW   00000011B  ; 1
        ANDWF   TMP1,W     ; 1
        ADDWF   PCL        ; 2
        GOTO    _CodeReception ; 2 SUM 5     
        GOTO    SETBIT1    ;          00  11     
        GOTO    SETBIT0    ;             
        GOTO    _CodeReception ;
SETBIT1:
        BSF     STATUS,C   ; 1
        DECFSZ  COUNT2     ; 1
        GOTO    RECEIPTBIT ; 2
        GOTO    SRHEADER
SETBIT0:
        BCF     STATUS,C   ; 1
        DECFSZ  COUNT2     ; 1
        GOTO    RECEIPTBIT ; 2
        ;
        ;    
        ;
SRHEADER:
        MOVLW   64                ; 1
        MOVWF   COUNT             ; 1
SRHEADER1:
        MOVLW   0E6h              ; 1  18*63 = 1134    
        XORWF   _COD1,W           ; 1
        BTFSC   STATUS,Z          ; 1
        RETLW   1                 ; 2   
        ;     
        BSF     STATUS,C          ; 1
        BTFSS   _COD1,7           ; 1
        BCF     STATUS,C          ; 1
        RLF     _COD8             ; 1
        RLF     _COD7             ; 1
        RLF     _COD6             ; 1
        RLF     _COD5             ; 1
        RLF     _COD4             ; 1
        RLF     _COD3             ; 1
        RLF     _COD2             ; 1
        RLF     _COD1             ; 1
        DECFSZ  COUNT             ; 1
        GOTO    SRHEADER1         ; 2
        RETLW   0                 ; 2   


        end
