#include <pic.h>
#include <sys.h>
#include <koyot.h>
#include <main.h>



bit bitTaskSw;   //        
bit oldPin_Door; //    
bit oldPin_ACC;  //    
bit bitACC_ON;   //   
bit bitACC_OFF;  //   
bit bitDoor_Open;//   
bit bitCodeAccepted1; //    1 
bit bitCodeAccepted2; //    2 
bit bitFault;        //     
bit bitEngineEnabled; //    
bit bitAttemptScanning;   //        

unsigned char  MODE;  //    

extern bank1 struct controlb modLED;
extern bank2 struct controlb modSir;


bank2 struct {              //      Open, Close
unsigned start  :1;
unsigned phaze  :1;
unsigned enabled:1;
unsigned stop   :1;
unsigned        :4;
} modOpen, modClose;
bank2 unsigned char cntOpen,cntClose; //      Open, Close

bank2 struct {             
unsigned Ant1Enabled:1;
unsigned Ant2Enabled:1;
unsigned phaze      :1;
unsigned            :5; 
} modAnt;                //     


unsigned char COD1;
unsigned char COD2;
unsigned char COD3;
unsigned char COD4;
unsigned char COD5;
unsigned char COD6;
unsigned char COD7;
unsigned char COD8;

unsigned bank1 char modLEDMode;
unsigned bank2 char modSirMode;

unsigned char Ant1TimeOut;
unsigned char Ant2TimeOut;
unsigned int BlockTimeOut; // - 

bank3 unsigned int timer1;
bank3 unsigned char counter1;

main()
{


  OPTION = 0b11000000 | Timer0Rate; //   = 256

  PORTB  = 0b00000100;
  TRISB  = 0b00001000;
//               ||||
//               |||+- BL
//               ||+-- LED
//               |+--- SIR
//               +---- Input
//
  PORTC  = 0b00101100;
  TRISC  = 0b00001100;
//             ||||||
//             |||||+- Open
//             ||||+-- Close
//             |||+--- ACC
//             ||+---- Door
//             |+----- Ant2
//             +------ Ant1

  oldPin_Door=1; //   -  
  oldPin_ACC=0;  //   -  
  
  bitCodeAccepted1=0;
  bitCodeAccepted2=0;
  bitEngineEnabled=0;
  
  TMR0=0;
  
  //       
  MODE=mdAlarm;

  modLEDMode=mdLEDAlarm;


  modAnt.Ant1Enabled=1;
  modAnt.Ant2Enabled=0;
  modSirMode=mdSirAlarm;
  modOpen.stop=1;
  modClose.start=1;

  timer1=0;
  counter1=0;



  
  //*****************************************************************************************************
  //    
  //
  //
  for (;;)
  {
    //    = 4000000/(4*256) = 3906.25  = 256 
    //      256*256=65536 
  
    while (TMR0!=0) {}  //         0
    
    //  ######################################################################################
    //
    //        Q 
    //

    //-------------------------------------------       
    //        
    //-------------------------------------------      

    //   
    //  . 1 :  
    //           0 :   
    if (Pin_ACC)
    {
      if (!oldPin_ACC) bitACC_OFF=1;
      oldPin_ACC=1;
    }
    else
    {
      if (oldPin_ACC) bitACC_ON=1;
      oldPin_ACC=0;
    }
   
    //   
    //  . 1 :  
    //           0 :   
    if (Pin_Door)
    {
      if (!oldPin_Door) bitDoor_Open=1;
      oldPin_Door=1;
    }
    else
    {
      oldPin_Door=0;
    }

    //-------------------------------------------      
    //   Bloc
    //-------------------------------------------
    if  (!Pin_ACC && bitEngineEnabled)  Pin_Block=1;
    if  (Pin_ACC)  Pin_Block=0; 
    if  (!Pin_ACC && (BlockTimeOut!=0))  
    {
      --BlockTimeOut;
      if (BlockTimeOut==0)
      {
      	 bitEngineEnabled=0; 
      	 Pin_Block=0;
      }	
    }	


    //-------------------------------------------      
    //   LED  Sir
    //-------------------------------------------
    
    Task_LED();
    Task_Sir();
    Task_Open();
    Task_Close();
    
    //  ######################################################################################
    //
    //        2*Q 
    //


    if (bitTaskSw)
    {
      //-------------------------------------------      
      //     
      //-------------------------------------------        
      bitTaskSw=0;
      
      bitCodeAccepted1=0;
      bitCodeAccepted2=0;


      CodeReception();

      if (((COD6==0x07)&&(COD7==0x43)&&(COD8==0x64)) |
          ((COD6==0x07)&&(COD7==0x40)&&(COD8==0x57)) |
          ((COD6==0x07)&&(COD7==0x40)&&(COD8==0x57)) |
          ((COD6==0x07)&&(COD7==0x40)&&(COD8==0x57))) 
      {
        
       	if (modAnt.phaze)
        {
          bitCodeAccepted2=1;
          Ant2TimeOut=TIMEOUT_ANT2;
        }  
        else
        {
          bitCodeAccepted1=1;
          Ant1TimeOut=TIMEOUT_ANT1;
        }  
      } 
      else
      {
      	if ((COD1==0xE6)&&(COD2==0x00)&&(COD3==0x00))
      	{
      		bitAttemptScanning=1;
      	}	
      }
      
      Pin_CtlAnt1=0;
      Pin_CtlAnt2=0;

    }
    else
    {
      //-------------------------------------------
      //    
      //-------------------------------------------        

      bitTaskSw=1;
      GeneralProc();     
  
      bitACC_ON=0;
      bitACC_OFF=0;
      bitDoor_Open=0;

      //-------------------------------------------      
      //   
      //-------------------------------------------

      if (modAnt.phaze) 
      {
        Pin_CtlAnt2=0;
        if (Ant1TimeOut==0) {	if (modAnt.Ant1Enabled) Pin_CtlAnt1=1; }
        else { --Ant1TimeOut; }
        modAnt.phaze=0;
      }  
      else
      {
      	if (Ant2TimeOut==0) {	if (modAnt.Ant2Enabled) Pin_CtlAnt2=1; }
      	else { --Ant2TimeOut; }
      	Pin_CtlAnt1=0;
        modAnt.phaze=1;
      }  

    



    }  // if (bitTaskSw)
    
      
// ------------------------------------------------------------------------------------------------------
//     
//
    //  ######################################################################################  

    while (TMR0==0) {} //      .
                       //        
    //  ######################################################################################  

  }      // for (;;)
}







