#define Pin_Door         RC3
#define Pin_ACC          RC2
#define Pin_Open         RC0
#define Pin_Close        RC1
#define Pin_Block        RB0
#define Pin_LED          RB1
#define Pin_INPUT        RB3 
#define Pin_Sir          RB2
#define Pin_CtlAnt1      RC5
#define Pin_CtlAnt2      RC4

#define Timer0Rate       7           //   = 256
//#define TimerDiv       256             
//#define	XTAL	         4000000         
#define Q                0.065536    //       (4*256*TimerDiv)/XTAL
                                     

#define CT(T)        ((unsigned char)(T/Q)) //   16.7      Q
#define IT(T)        ((unsigned int)(T/Q))  //   4294 

#define LOW_STATE_OPEN   CT(0.5)  //      Open   1 
#define HIGH_STATE_OPEN  CT(1.3)  //      Open   1 
#define LOW_STATE_CLOSE  CT(0.5)  //      Close   1 
#define HIGH_STATE_CLOSE CT(1.3)  //      Close   1 

#define TIMEOUT_ANT1 CT(5/4) // -   
#define TIMEOUT_ANT2 CT(5/4)

#define mdAlarm          1
#define mdArm            2
#define mdArmRelease     3
#define mdBlock1         4
#define mdBlock2         5
#define mdDrive          6

/*
#define mdBlock2_1       1
#define mdBlock2_2       2
#define mdBlock2_3       3
#define mdBlock2_4       4
#define mdBlockON        5
*/

#define BLOCK2_1         IT(20)  //     2 
#define BLOCK2_2         IT(10)  //     2 
#define BLOCK2_3         IT(5)   //     2 
#define BLOCK2_4         1       //     2 


#define mdLEDArm         1
#define mdLEDArm_Break   2
#define mdLEDAlarm       2
#define mdLEDArm_Release 3
#define mdLEDBlockACCOn  4
#define mdLEDBlockACCOff 5
#define mdLEDCod2Confirm 6

#define LEDARM_ON     1 
#define LEDARM_OFF    2 
#define LEDARM_PULSE  4  
#define LEDARM_PERIOD CT(2)

#define LEDARMBREAK_ON     8 
#define LEDARMBREAK_OFF    8 
#define LEDARMBREAK_PULSE  2  
#define LEDARMBREAK_PERIOD 16  

#define LEDARMRELEASE_ON     1 
#define LEDARMRELEASE_OFF    10 
#define LEDARMRELEASE_PULSE  2  
#define LEDARMRELEASE_PERIOD 11  

#define LEDARMBLOCKACCON_ON     8 
#define LEDARMBLOCKACCON_OFF    2 
#define LEDARMBLOCKACCON_PULSE  2  
#define LEDARMBLOCKACCON_PERIOD 10  

#define LEDARMBLOCKACCOFF_ON     2
#define LEDARMBLOCKACCOFF_OFF    8 
#define LEDARMBLOCKACCOFF_PULSE  2  
#define LEDARMBLOCKACCOFF_PERIOD 10  

#define LEDARMCOD2CONFIRM_ON     1 
#define LEDARMCOD2CONFIRM_OFF    2 
#define LEDARMCOD2CONFIRM_PULSE  8  
#define LEDARMCOD2CONFIRM_PERIOD 20  



#define mdSirAlarm       1
#define mdSirArm_ON      2
#define mdSirArm_OFF     3
#define mdSirArm_ONWarning    4


#define SIRALARM_ON        CT(10) 
#define SIRALARM_OFF       2
#define SIRARMBREAK_PULSE  2  
#define SIRARMBREAK_PERIOD CT(11)  

#define SIRARMON_ON        2 
#define SIRARMON_OFF       1
#define SIRARMON_PULSE     2  
#define SIRARMON_PERIOD    4  

#define SIRARMOFF_ON       1 
#define SIRARMOFF_OFF      2 
#define SIRARMBOFF_PULSE   4  
#define SIRARMBOFF_PERIOD  8 

#define SIRARMONWARNING_ON        CT(7) 
#define SIRARMONWARNING_OFF       1 
#define SIRARMBONWARNING_PULSE    2
#define SIRARMBONWARNINGF_PERIOD  CT(8) 

struct controlb {              
unsigned startMode:3;
unsigned stop     :1;
unsigned enabled  :1;
unsigned phaze    :1;
unsigned single   :1; //   
unsigned          :1; 
};
